## netperfmeter-1.9.3.tar.xz

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.2)
PROJECT(netperfmeter LANGUAGES C CXX)

SET(BUILD_MAJOR "1")
SET(BUILD_MINOR "9")
SET(BUILD_PATCH "3")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})

SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_EXTENSIONS OFF)


#############################################################################
# INSTALLATION_DIRECTORIES
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
# PACKAGING
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
   "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES
   "${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}-*;${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}_*;/build/;/.git/;/config.log;/CMakeFiles/;CMakeCache.txt$;.cmake$;.tar.gz$;/_CPack_Packages;/Makefile$;~$;/build-deb;/clean-deb;/filter-empty-entries;/make-symbols;/make-ppa;/make-deb;/debian.conf;/make-rpm;/rpm.conf;${CPACK_SOURCE_IGNORE_FILES}")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


INCLUDE(CheckIncludeFile)
INCLUDE(CheckStructHasMember)
INCLUDE(CheckCCompilerFlag)


#############################################################################
# OS DEPENDENT
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    ADD_DEFINITIONS("-DHAVE_MPTCP")   # Any better solution for this?
    FIND_LIBRARY(SCTP_LIB sctp)

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
# CHECK STRUCT MEMBERS
#############################################################################

CHECK_STRUCT_HAS_MEMBER("struct sockaddr" "sa_len" "sys/types.h;sys/socket.h" HAVE_SA_LEN)
IF (HAVE_SA_LEN)
    MESSAGE(STATUS "HAVE_SA_LEN")
    ADD_DEFINITIONS(-DHAVE_SA_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in" "sin_len" "sys/types.h;netinet/in.h" HAVE_SIN_LEN)
IF (HAVE_SIN_LEN)
    MESSAGE(STATUS "HAVE_SIN_LEN")
    ADD_DEFINITIONS(-DHAVE_SIN_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in6" "sin6_len" "sys/types.h;netinet/in.h" HAVE_SIN6_LEN)
IF (HAVE_SIN6_LEN)
    MESSAGE(STATUS "HAVE_SIN6_LEN")
    ADD_DEFINITIONS(-DHAVE_SIN6_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_storage" "ss_len" "sys/types.h;sys/socket.h" HAVE_SS_LEN)
IF (HAVE_SS_LEN)
    MESSAGE(STATUS "HAVE_SS_LEN")
    ADD_DEFINITIONS(-DHAVE_SS_LEN)
ENDIF()


#############################################################################
# CHECK OPTIONS
#############################################################################

OPTION(BUILD_TEST_PROGRAMS "Build test programs" 0)
OPTION(BUILD_PLOT_PROGRAMS "Build plot programs" 0)


#############################################################################
# REQUIREMENTS
#############################################################################

# ###### Threads ############################################################
FIND_PACKAGE(Threads REQUIRED)


# ###### SCTP ###############################################################
OPTION(USE_KERNEL_SCTP "Use Kernel SCTP" 1)
IF (USE_KERNEL_SCTP)
   # ====== Kernel SCTP =====================================================
   CHECK_INCLUDE_FILE(netinet/sctp.h HAVE_NETINET_SCTP_H)
   IF (HAVE_NETINET_SCTP_H)
      SET(SCTP_INCLUDE "netinet/sctp.h")
      ADD_DEFINITIONS(-DHAVE_KERNEL_SCTP -DHAVE_NETINET_SCTP_H)
   ENDIF()

ELSE()
   # ====== SCTPLIB User-Space SCTP =========================================
   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPLIB_SCTP_H)
   FIND_LIBRARY(SCTPLIB_LIB sctplib)
   MESSAGE(STATUS "sctplib found: ${SCTPLIB_LIB}")
   IF (NOT HAVE_SCTPLIB_SCTP_H OR NOT SCTPLIB_LIB)
      MESSAGE(FATAL_ERROR "sctplib not found - libsctplib installed?")
   ENDIF()

   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPSOCKET_SCTP_H)
   FIND_LIBRARY(SCTPSOCKET_LIB sctpsocket)
   MESSAGE(STATUS "sctpsocket found: ${SCTPSOCKET_LIB}")
   IF (NOT HAVE_SCTPSOCKET_SCTP_H OR NOT SCTPSOCKET_LIB)
      MESSAGE(FATAL_ERROR "sctpsocket not found - libsctpsocket installed?")
   ENDIF()

   FIND_PACKAGE(PkgConfig)
   PKG_CHECK_MODULES(GLIB glib-2.0)
   IF (NOT ${GLIB_LIBS})
      MESSAGE(FATAL_ERROR "glib not found - glib-2.0 installed?")
   ENDIF()

   SET(SCTP_LIB ${SCTPSOCKET_LIB} ${SCTPLIB_LIB} ${GLIB_LIBRARIES})
ENDIF()


# ###### NEAT ###############################################################
OPTION(WITH_NEAT "Include NEAT support" 0)
IF (WITH_NEAT)
   CHECK_INCLUDE_FILE(neat-socketapi.h HAVE_NEAT_SOCKETAPI_H)
   FIND_LIBRARY(NEAT_SOCKETAPI_LIB neat-socketapi)
   MESSAGE(STATUS "neat-socketapi found: ${NEAT_SOCKETAPI_LIB}")
   IF (NOT HAVE_NEAT_SOCKETAPI_H OR NOT NEAT_SOCKETAPI_LIB)
      MESSAGE(FATAL_ERROR "neat-socketapi not found - neat-socketapi installed?")
   ENDIF()
ENDIF()


# ###### BZip2 ##############################################################
find_package(BZip2 REQUIRED)


# ###### IEEE Floating-Point ################################################
INCLUDE(CheckCSourceRuns)
CHECK_C_SOURCE_RUNS("
#include <stdio.h>

union DoubleIntUnion
{
   double             Double;
   unsigned long long Integer;
};

int main (int argc, char** argv)
{
   union DoubleIntUnion value;

   value.Double = 0.0;
   if(value.Integer != 0ULL) {
      return(1);
   }
   value.Double = 1000.5;
   if(value.Integer != 0x408f440000000000ULL) {
      return(1);
   }
   value.Double = -1000.5;
   if(value.Integer != 0xc08f440000000000ULL) {
      return(1);
   }

   return(0);
}"
USES_IEEEFP_FP)

IF (USES_IEEEFP_FP)
   ADD_DEFINITIONS(-DHAVE_IEEE_FP)
ENDIF()


# ###### DCCP support #######################################################
CHECK_C_SOURCE_RUNS("
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/dccp.h>

int main (int argc, char** argv)
{
   volatile int domain = IPPROTO_DCCP;
   volatile int type   = SOCK_DCCP;
   volatile int opt    = DCCP_SOCKOPT_SERVICE;
   return(0);
}"
HAVE_DCCP)

IF (HAVE_DCCP)
   ADD_DEFINITIONS(-DHAVE_DCCP)
ENDIF()


#############################################################################
# COMPILER FLAGS
#############################################################################

SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -O2 -Wall")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 -Wall")

# ------ Check for "address-of-packed-member" -------------------------------
CHECK_C_COMPILER_FLAG("-Waddress-of-packed-member -Werror" HAS_ADDRESS_OF_PACKED_MEMBER)
IF (HAS_ADDRESS_OF_PACKED_MEMBER)
   # Disable "address-of-packed-member" warning:
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wno-address-of-packed-member")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-address-of-packed-member")
ENDIF()

# ------ Check for "array-bounds" -------------------------------------------
CHECK_C_COMPILER_FLAG("-Warray-bounds -Werror" HAS_ARRAY_BOUNDS)
IF (HAS_ARRAY_BOUNDS)
   # Disable "array-bounds" warning:
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wno-array-bounds")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-array-bounds")
ENDIF()

# ------ Check for "overlength-strings" -------------------------------------
CHECK_C_COMPILER_FLAG("-Woverlength-strings -Werror" HAS_OVERLENGTH_STRINGS)
IF (HAS_OVERLENGTH_STRINGS)
   # Disable "overlength-strings" warning:
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wno-overlength-strings")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-overlength-strings")
ENDIF()

# ------ Check for "unused-function" ----------------------------------------
CHECK_C_COMPILER_FLAG("-Wunused-function -Werror" HAS_UNUSED_FUNCTION)
IF (HAS_UNUSED_FUNCTION)
   # Disable "unused-function" warning:
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wno-unused-function")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
ENDIF()

# ------ Check for "unused-parameter" ---------------------------------------
CHECK_C_COMPILER_FLAG("-Wunused-parameter -Werror" HAS_UNUSED_PARAMETER)
IF (HAS_UNUSED_PARAMETER)
   # Disable "unused-parameter" warning:
   SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wno-unused-parameter")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
ENDIF()


#############################################################################
# SUBDIRECTORIES
#############################################################################

ADD_SUBDIRECTORY(src)

=== debian/changelog ===
netperfmeter (1.9.3-1ubuntu1) jammy; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.6.1.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 11 Sep 2022 13:05:06 +0200

netperfmeter (1.9.2-1ubuntu1) jammy; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 07 Nov 2021 20:05:41 +0100

netperfmeter (1.9.1-1ubuntu1) hirsute; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.6.0.1.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 01 Nov 2021 09:53:15 +0100

netperfmeter (1.9.0-1ubuntu1) hirsute; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.5.1.0.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sat, 06 Mar 2021 23:41:07 +0100

netperfmeter (1.8.7-1ubuntu1) hirsute; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.5.0.3.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 13 Nov 2020 19:00:14 +0100

netperfmeter (1.8.6-1ubuntu1) focal; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.5.0.0.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 07 Feb 2020 13:21:53 +0100

netperfmeter (1.8.5-1ubuntu1) eoan; urgency=medium

  * New upstream release.
  * Renamed pdfmetadata to setpdfmetadata (Closes: #914333).
  * Added missing test script (Closes: #914336).

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Tue, 10 Sep 2019 14:46:09 +0300

netperfmeter (1.8.4-1ubuntu1) disco; urgency=medium

  * New upstream release.
  * Closes: #914333 (ITP).

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 07 Aug 2019 18:14:15 +0200

netperfmeter (1.8.3-1ubuntu1) disco; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 26 Jul 2019 12:08:26 +0200

netperfmeter (1.8.2-1ubuntu1) disco; urgency=medium

  * New upstream release
  * Renamed pdfmetadata to setpdfmetadata (Closes: #914333).

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 22 Jul 2019 09:59:56 +0200

netperfmeter (1.8.1-1ubuntu1) disco; urgency=medium

  * New upstream version.
  * debian/control: updated standards version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 27 Feb 2019 08:08:08 +0800

netperfmeter (1.8.0-1ubuntu1) cosmic; urgency=low

  * New upstream version.
  * debian/control: updated standards version.
  * debian/copyright: updated.
  * debian/upstream/metadata: added metadata file.
  * debian/tests/control: added tests control file.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 17 Oct 2018 08:08:08 +0200

netperfmeter (1.7.7-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/control: updated standards version.
  * debian/copyright: updated.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 06 Jun 2018 08:08:08 +0200

netperfmeter (1.7.6-1ubuntu1) xenial; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 29 Oct 2017 08:08:08 +0200

netperfmeter (1.7.5-1ubuntu1) xenial; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 25 Aug 2017 08:08:08 +0200

netperfmeter (1.7.4-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/watch: URL update
  * debian/control: URL update

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 09 Aug 2017 08:08:08 +0200

netperfmeter (1.7.3-1ubuntu1) xenial; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Tue, 08 Aug 2017 08:08:08 +0200

netperfmeter (1.7.2-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/watch: fixed URL.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 07 Aug 2017 08:08:08 +0200

netperfmeter (1.7.1-1ubuntu1) xenial; urgency=low

  * New upstream version.
  * debian/rules: autoconf/automake -> cmake
  * debian/control: autoconf/automake -> cmake

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 07 Aug 2017 08:08:08 +0200

netperfmeter (1.7.0-1ubuntu1) zesty; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Thu, 20 Apr 2017 08:08:08 +0200

netperfmeter (1.6.1-1ubuntu1) zesty; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 04 Nov 2016 08:08:08 +0200

netperfmeter (1.6.0-1ubuntu1) yakkety; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Wed, 17 Aug 2016 08:08:08 +0200

netperfmeter (1.5.6-1ubuntu1) yakkety; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 29 Apr 2016 08:08:08 +0200

netperfmeter (1.5.5-1ubuntu1) wily; urgency=low

  * New upstream version.
  * debian/control: Updated standards version.
  * debian/control: added dependency dpkg-dev for hardening options.
  * debian/copyright: fix for machine-readable format.
  * debian/rules: using buildflags.mk for hardening options.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 04 Apr 2016 08:08:08 +0200

netperfmeter (1.5.4-1ubuntu1) vivid; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Mon, 11 May 2015 08:08:08 +0200

netperfmeter (1.5.3-1ubuntu1) vivid; urgency=low

  * New upstream version.
  * debian/copyright: changed to machine-readable format.
  * debian/control: updated standards version.
  * debian/watch: added pgpsigurlmangle option.
  * debian/upstream/signing-key.asc: added upstream public key.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Sun, 01 Mar 2015 08:08:08 +0200

netperfmeter (1.5.2-1ubuntu1) vivid; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Thu, 05 Feb 2015 08:08:08 +0200

netperfmeter (1.5.0-1ubuntu1) utopic; urgency=low

  * New upstream version.

 -- Thomas Dreibholz <dreibh@iem.uni-due.de>  Fri, 14 Nov 2014 08:08:08 +0200

netperfmeter (1.4.0-1ubuntu1) utopic; urgency=low

  * New upstream version.
  * debian/control: Added libfile-fcntllock-perl to get rid of


=== debian/control ===
Source: netperfmeter
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <dreibh@iem.uni-due.de>
Homepage: https://www.uni-due.de/~be0001/netperfmeter/
Build-Depends: cmake (>= 3.0.2) | cmake3,
               debhelper (>= 9),
               libbz2-dev (>= 1.0),
               libfile-fcntllock-perl,
               libsctp-dev (>= 1.0.5)
Standards-Version: 4.6.1
Rules-Requires-Root: no

Package: pdfproctools
Architecture: all
Depends: ghostscript,
         libpdf-api2-perl,
         perl (>= 5.8.0),
         qpdf,
         ${misc:Depends},
         ${shlibs:Depends}
Description: PDF Processing Tools
 This package contains tools for PDF file processing.
 .
 SetPDFMetadata updates the metadata of a PDF file. In particular, it can be
 used to add outlines (bookmarks) to a document. Furthermore, it can set the
 document properties (e.g. author, title, keywords, creator, producer).
 .
 PDFEmbedFonts embeds all referenced fonts into a PDF file. Optionally, it
 can also linearize the PDF file for online publication
 ("fast web view", "optimized").

Package: netperfmeter-plotting
Architecture: all
Depends: pdfproctools,
         r-base,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Network Performance Meter (plotting program)
 NetPerfMeter is a network performance meter for the UDP,
 TCP, MPTCP, SCTP and DCCP transport protocols over IPv4 and IPv6.
 It simultaneously transmits bidirectional flows to an endpoint
 and measures the resulting flow bandwidths and QoS. The
 results are written as vector and scalar files. The vector
 files can e.g. be used to create plots of the results.
 .
 This package contains a plotting program for the results.

Package: netperfmeter
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: bc,
            hipercontracer,
            iputils-ping,
            iputils-tracepath,
            netperfmeter-plotting,
            subnetcalc (>= 2.0.2),
            traceroute
Description: Network Performance Meter (measurement program)
 NetPerfMeter is a network performance meter for the UDP,
 TCP, MPTCP, SCTP and DCCP transport protocols over IPv4 and IPv6.
 It simultaneously transmits bidirectional flows to an endpoint
 and measures the resulting flow bandwidths and QoS. The
 results are written as vector and scalar files. The vector
 files can e.g. be used to create plots of the results.
 .
 This package contains the measurement program.
